/*---------------------------------------------------
-----------------------------------------------------
Filename:	init_browser.m
Version:	1.1

Type:		maki/attrib definitions
Date:		27. Jul. 2007 - 13:36 
Author:		Martin Poehlmann aka Deimos
E-Mail:		martin@skinconsortium.com
Internet:	www.skinconsortium.com
			www.martin.deimos.de.vu
-----------------------------------------------------
Depending Files:
		scripts/browser.maki
-----------------------------------------------------
---------------------------------------------------*/

#ifndef included
#error This script can only be compiled as a #include
#endif

#include "gen_pageguids.m"

#define CUSTOM_PAGE_BROWSER "{0E17DBEA-9398-49e6-AE6F-3AB17D001DF3}"

Function initAttribs_browser();

Class ConfigAttribute SearchAttribute;
Function check (string unknown, SearchAttribute compare);

#ifdef BROWSER_SCRIPT
Global list SearchAttributeList;
#endif
#ifndef BROWSER_SCRIPT
#define SearchAttributeList //
#endif

Global ConfigAttribute browser_scr_show_attrib, browser_search_attrib;
Global SearchAttribute browser_search_winamp_web_attrib, browser_search_wiki_attrib;

initAttribs_browser()
{
	initPages();

	ConfigItem custom_page_browser = addConfigSubMenu(optionsmenu_page, "Browser", CUSTOM_PAGE_BROWSER);

	browser_search_attrib = custom_page_nonexposed.newAttribute("Onesie browser Quicksearch", "Web Search");

	SearchAttributeList = new List;
	SearchAttributeList.addItem (custom_page_browser);

	browser_search_winamp_web_attrib = custom_page_browser.newAttribute("Web Search", "1");
	SearchAttributeList.addItem (browser_search_winamp_web_attrib);

	browser_search_wiki_attrib = custom_page_browser.newAttribute("Wikipedia Search", "0");
	SearchAttributeList.addItem (browser_search_wiki_attrib);

	addMenuSeparator(custom_page_browser);

	browser_scr_show_attrib = custom_page_browser.newAttribute("Show Media Monitor", "1");
}

#ifdef MAIN_ATTRIBS_MGR

browser_search_attrib.onDataChanged ()
{
	if (attribs_mychange) return;
	string dta = getData();
	if (dta == "Web Search with Google") browser_search_winamp_web_attrib.setData("1");
	else if (dta == "Wikipedia Search") browser_search_wiki_attrib.setData("1");
}

SearchAttribute.onDataChanged()
{
	if (attribs_mychange) return;
	NOOFF
	attribs_mychange = 1;
	String s = SearchAttribute.getAttributeName();
	check (s, browser_search_winamp_web_attrib);
	check (s, browser_search_wiki_attrib);

	attribs_mychange = 0;
}

check (String unknown, SearchAttribute compare)
{
	if (unknown == compare.getAttributeName())
	{
		browser_search_attrib.setData(compare.getAttributeName());
	}
	else
	{
		compare.setData("0");
	}
}

#endif